
#include "C_Brain.h"

WORLD_COOR particle_wherenext(Particle* it)
{
	WORLD_COOR delta; //FACING temp;
	delta.x = delta.y = delta.z = 0;

	switch (it->type) {

	case _BULLET:
		 delta = world_coor_mult(BULLET_SPEED/FPS_CAP*btfactor/100.0,
											normalize(Angle2Vec(it->facing.hor_angle, it->facing.ver_angle)));
		delta = world_coor_add(it->pos.x,it->pos.y,it->pos.z, delta.x,delta.y,delta.z);

		if ((it->health) > 1) { (it->health)-=btfactor/100.0; return delta;}
		else if (isCollide(delta,0,_BULLET, -1)) {
			delta.y = -100;
			return delta;
		}
		else
			return delta;

	case _SMART_BOMB:
		// much like tank;
		delta = world_coor_mult(WB_SPEED/FPS_CAP*btfactor/100.0,
			normalize(Angle2Vec(it->facing.hor_angle, it->facing.ver_angle)));
		delta = world_coor_add(it->pos.x,it->pos.y,it->pos.z, delta.x,delta.y,delta.z);
		// correct facing according to target:
		if (missile_target.y >= 0)
		{
			if (it->pos.y < 40 && !it->tar_locked) { missile_target = it->pos; missile_target.y = 40; }
			else { it->tar_locked = true;}
            
			WORLD_COOR w = world_coor_add(missile_target.x, missile_target.y, missile_target.z, -it->pos.x,-it->pos.y,-it->pos.z);
			FACING f = Vec2Angle(w.x, w.y, w.z);

			//cout << f.hor_angle << " " << f.ver_angle << endl;
			
			it->facing.hor_angle += turn(it->facing.hor_angle, f.hor_angle)*SB_TURNING_SPEED/FPS_CAP*btfactor/100.0;
			uniformAngle(&it->facing.hor_angle);
			int pit = pitch(it->facing.ver_angle, f.ver_angle);
			it->facing.ver_angle += pit*SB_TURNING_SPEED/FPS_CAP*btfactor/100.0;

			
			uniformAngle(&it->facing.ver_angle);
			uniformFacing(&it->facing);
		}

		if ((it->health) > 1) { (it->health)-=btfactor/100.0; return delta;}
		else if (isCollide(delta,0,_SMART_BOMB, -1)) {
			delta.y = -100;
			return delta;
		}
		else
			return delta;


	case _WALKING_BOMB:
		delta = world_coor_mult(WB_SPEED/FPS_CAP*btfactor/100.0,
			normalize(Angle2Vec(it->facing.hor_angle, 0)));
		delta = world_coor_add(it->pos.x,it->pos.y,it->pos.z, delta.x,0,delta.z); // should get y from the terrain

		if ((it->health) > 1) { (it->health)-=btfactor/100.0; return delta;}
		else if (isCollide(delta,0,_WALKING_BOMB, -1)) {
			delta.y = -100;
			return delta;
		}
		else
			return delta;

	case _BOMB:
		 //delta = world_coor_mult(BOMB_SPEED/FPS_CAP*btfactor/100.0,
			//								normalize(Angle2Vec(it->facing.hor_angle, it->facing.ver_angle)));
		 //delta.y -= g/FPS_CAP*btfactor/100.0; // vertical v - g / frame
		 //// update facing
		 //it->facing = Vec2Angle(delta.x, delta.y, delta.z);
		 //delta =  world_coor_add(it->pos.x,it->pos.y,it->pos.z, delta.x,delta.y,delta.z);
		
		// try cycle
		 delta = world_coor_mult(BOMB_SPEED/FPS_CAP*btfactor/100.0,
											normalize(Angle2Vec(it->facing.hor_angle, it->facing.ver_angle)));
		delta = world_coor_add(it->pos.x,it->pos.y,it->pos.z, delta.x,delta.y,delta.z);

		it->facing.ver_angle += (float)BOMB_A_SPEED/60*btfactor/100.0;
		uniformFacing(&it->facing);
	
		if ((it->health) > 1) { (it->health)-=btfactor/100.0; return delta;}
		else if (isCollide(delta,0,_BOMB, -1)) {
			delta.y = -100;
			return delta;
		}
		else
			return delta;

		//temp = Vec2Angle(it->pos.x - it->center.x, it->pos.y - it->center.y, it->pos.z - it->center.z);
		//temp.hor_angle
	//	return ;b

	default:
		return delta;
	}
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
//																			brain processes eneTanks
void tank_whatnext(EnemyTank *it, int tankNum)
{
	// check health,, maybe it's dead
	if (it->health < 0) {
		for (int i=0; i<PDUST_NUM; i++)
		{
			if (pdusts[i] == NULL) {
				pdusts[i] = new Particledust(it->pos, _DUST_S1);
				break;
			}
		}
		tanks[it->tankNum] = new EnemyTank(it->type, tankNum);
		tanks[it->tankNum]->regeneration();
		n_DeathCNT++;
	}

	// :: each frame, check frame counter 
	if (it->fire_holdup > 0) it->fire_holdup--;

	// :: update gun facing :::::::::::::::::::::::::::::::::::::
	WORLD_COOR w = world_coor_add(player->pos.x, player->pos.y, player->pos.z, -it->pos.x, -it->pos.y, -it->pos.z);
	it->intended_facing = Vec2Angle(w.x, w.y, w.z);

	// check if ok to fire
	int tit = turn(it->gun_facing_flat.hor_angle, it->intended_facing.hor_angle);
	int pit = pitch(it->gun_facing_flat.ver_angle, it->intended_facing.ver_angle);
	if ( tit == 0 && pit == 0 && it->fire_holdup == 0 && it->gun_pitch > 0) {
		it->fire();
		it->fire_holdup = TANK_FIRE_HOLDUP_COUNTER*FPS_CAP;
	}
	else { // update gun_facing_flat
		it->gun_facing_flat.hor_angle = it->gun_facing_flat.hor_angle + tit*it->gun_turning_speed;
		uniformAngle(&it->gun_facing_flat.hor_angle);
		it->gun_facing_flat.ver_angle = it->gun_facing_flat.ver_angle + pit*it->gun_turning_speed;
		uniformAngle(&it->gun_facing_flat.ver_angle);
	}
    // :: - now update gun_facing_abs
	it->gun_pitch = updateGunPitch(it);
	it->gun_facing_abs = it->gun_facing_flat;
	it->gun_facing_abs.ver_angle -= it->gun_pitch;
	uniformFacing(&it->gun_facing_abs);

	// so update relative angle
	it->gun_facing_rel = abs2rel(it->rolling, it->facing.ver_angle, it->facing.hor_angle, it->gun_facing_abs);
	if (it->gun_facing_rel.ver_angle < 315 && it->gun_facing_rel.ver_angle >= 270) {
		it->gun_facing_rel.ver_angle = 315;
		if (it->gun_facing_rel.ver_angle > 5 && it->gun_facing_rel.ver_angle <= 90) 
			it->gun_facing_rel.ver_angle = 5;
	}

	//// now i hav to back update it's abs facing,,
	//it->gun_facing_abs = rel2abs(-it->rolling, -it->facing.ver_angle, -it->facing.hor_angle, it->gun_facing_rel);
	//it->gun_facing_flat = it->gun_facing_abs;
	//it->gun_facing_flat.ver_angle -= it->gun_pitch;
    
	// :: update tank facing ::::::::::::::::::::::::::::::::::::
	tit = turn(it->facing.hor_angle, it->intended_facing.hor_angle);
	it->newfacing.hor_angle = it->facing.hor_angle + tit*it->turning_speed;
	it->newfacing.ver_angle = it->facing.ver_angle;

	uniformAngle(&it->newfacing.hor_angle); // no need to uniform,, ver is not changed
	it->facing = it->newfacing;


	// :: try move ::::::::::::::::::::::::::::::::::::::::::::::
	w = world_coor_mult(it->speed*btfactor/100.0,
											normalize(Angle2Vec(it->newfacing.hor_angle, 0)));
	it->newpos = world_coor_add(it->pos.x,it->pos.y,it->pos.z, w.x,w.y,w.z);
	if (!isCollide(it->newpos, it->radius, it->type, tankNum)) {
		it->pos = it->newpos; it->newfacing;
	}
	else {
	
	// new facing caused the collision
	// try old direction
        w = world_coor_mult(it->speed*btfactor/100.0,
											normalize(Angle2Vec(it->facing.hor_angle, 0)));
		it->newpos = world_coor_add(it->pos.x,it->pos.y,it->pos.z, w.x,w.y,w.z);
		if (!isCollide(it->newpos, it->radius, it->type, tankNum))
			it->pos = it->newpos; // facing remains
		else {
		// try the other direction havent tried before
			float angle = it->facing.hor_angle - tit*it->turning_speed;
			uniformAngle(&angle);
			w = world_coor_mult(it->speed*btfactor/100.0, normalize(Angle2Vec(angle, 0)));
			it->newpos = world_coor_add(it->pos.x,it->pos.y,it->pos.z, w.x,w.y,w.z);
			if (!isCollide(it->newpos, it->radius, it->type, tankNum)) {
				it->pos = it->newpos; it->facing.hor_angle -= it->turning_speed;
			}
			else it->facing.hor_angle += 2*it->turning_speed; // turn only
	 //try right -- turn move or just turn
		}
	}
	it->pos.y = terrain->CollisionPoint(it->pos.x, it->pos.z);
}
// helper - determine gun ver facing according to user pos
float updateGunPitch(EnemyTank* it)
{
	float dist = veclength(world_coor_add(player->pos.x, player->pos.y, player->pos.z,-it->pos.x, -it->pos.y, -it->pos.z));
	if (dist <= 1.414* it->bomb_radius)
		return asin( dist / 2 / it->bomb_radius)*180/PI;
	else return 0;
}

bool isCollide(WORLD_COOR coor, float radius, int objecttype, int tankNum)
{
	// radius is very useful here, things that damage on hit has radius 0.1 & 0.2 & 0.3
	bool result = false;
	Blocks* b; EnemyTank* t;

	for (int i=0; i< BLOCK_NUM; i++) { // iterate through all blocks for detection
		b = blocks[i];
		if (b != NULL) {
		result = ((coor.x <= (b->pos.x + b->length/2 + radius)) && (coor.x >= (b->pos.x - b->length/2 - radius))
			 && (coor.z <= (b->pos.z + b->width/2 + radius)) && (coor.z >= (b->pos.z - b->width/2 - radius)) 
			&& (coor.y <= (b->pos.y + b->height + radius)) && (coor.y >= (b->pos.y - radius)));
		if (result) return true;
		}
	}

	for (int i=0; i< ENEMY_NUM; i++) { // iterate through all 
		t = tanks[i];
		if (t != NULL) {
		if (tankNum != i) {
		float c = veclength(world_coor_add(t->pos.x, t->pos.y, t->pos.z, -coor.x, -coor.y, -coor.z));
		result = (c <= (radius+t->radius));
		if (result) {
			if (objecttype==_BULLET || objecttype==_SMART_BOMB || objecttype==_WALKING_BOMB || objecttype==_BOMB)
				tanks[i]->hit = objecttype;
				if (objecttype == _BULLET) n_BH++;
			return true; }
		}
		}
	}
    
	// player
	if (objecttype != _PLAYER && player != NULL)
        if( veclength(world_coor_add(player->pos.x, player->pos.y, player->pos.z, -coor.x, -coor.y, -coor.z)) 
			<= radius+player->radius )
		{ if (objecttype == _BOMB) n_Hurt++; return true; } 
	else return false;

	return false; // by default
}

// 

void generatenewpos(EnemyTank* t)
{
	rand();
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
//																						AI helper
int turn(float curA, float tarA)	
// return 1,0,-1 for clock/counterclock turn | stall
{
	if ( curA >= tarA-0.5 && curA <= tarA+0.5) // here precision can be edited
		return 0;
	if (curA < tarA)
		if (tarA-curA > 180) return -1;
		else return 1;
	else
		if (curA-tarA > 180) return 1;
		else return -1;
}
int pitch(float curA, float tarA)
// return 1,0,-1 for up/down pitch | stall
{
	if ( curA >= tarA-1 && curA <= tarA+1)
		return 0;
	if (curA >=0 && curA <=90)
		if ( tarA >=270) return -1;
		else if (curA < tarA) return 1;
		else return -1;
	else
		if ( tarA <=90) return 1;
		else if (curA < tarA) return 1;
		else return -1;
}


