
#include "C_EneTanks.h"

EnemyTank::EnemyTank(int type, int tankNum)
{
	switch(type) {
		case _JEEP:
			pos.x = 0; pos.y = 20; pos.z = 0;
			facing.hor_angle = 0; facing.ver_angle = 0;	rolling = 0;

			gun_facing_flat.hor_angle = 0;
			gun_facing_flat.ver_angle = 0;
			gun_facing_abs.hor_angle=0;
			gun_facing_abs.ver_angle=0;
			gun_facing_rel = abs2rel(rolling,facing.ver_angle,facing.hor_angle, gun_facing_abs); 
			gun_pitch = 0;

			speed = (float)TANK_SPEED/FPS_CAP;
			health= 50;

			hit = 0;
			radius = 2;
			turning_speed = (float)TANK_SPEED/FPS_CAP;
			gun_turning_speed = (float)TANK_GUN_TURNING_SPEED/FPS_CAP;

			fire_holdup = 0;

			bomb_radius = BOMB_SPEED/1.414*2;

			this->type = type; // this is only for drawing differ things,, maybe shot..
			this->tankNum = tankNum;
			break;
		case _MOMMATH:
			pos.x = 0; pos.y = 20; pos.z = 0;
			facing.hor_angle = 0; facing.ver_angle = 0;	rolling = 0;

			gun_facing_flat.hor_angle = 0;
			gun_facing_flat.ver_angle = 0;
			gun_facing_abs.hor_angle=0;
			gun_facing_abs.ver_angle=0;
			gun_facing_rel = abs2rel(rolling,facing.ver_angle,facing.hor_angle, gun_facing_abs); 
			gun_pitch = 0;

			speed = (float)TANK_SPEED/5/FPS_CAP;
			health= 300;

			hit = 0;
			radius = 3;
			turning_speed = (float)TANK_SPEED/3/FPS_CAP;
			gun_turning_speed = (float)TANK_GUN_TURNING_SPEED/3/FPS_CAP;

			fire_holdup = 0;

			bomb_radius = BOMB_SPEED/1.414*2;

			this->type = type; // this is only for drawing differ things,, maybe shot..
			this->tankNum = tankNum;
			break;
		case _M1:
			pos.x = 0; pos.y = 20; pos.z = 0;
			facing.hor_angle = 0; facing.ver_angle = 0;	rolling = 0;

			gun_facing_flat.hor_angle = 0;
			gun_facing_flat.ver_angle = 0;
			gun_facing_abs.hor_angle=0;
			gun_facing_abs.ver_angle=0;
			gun_facing_rel = abs2rel(rolling,facing.ver_angle,facing.hor_angle, gun_facing_abs); 
			gun_pitch = 0;

			speed = (float)TANK_SPEED/3/FPS_CAP;
			health= 100;

			hit = 0;
			radius = 2;
			turning_speed = (float)TANK_SPEED/2/FPS_CAP;
			gun_turning_speed = (float)TANK_GUN_TURNING_SPEED/2/FPS_CAP;

			fire_holdup = 0;

			bomb_radius = BOMB_SPEED/1.414*2;

			this->type = type; // this is only for drawing differ things,, maybe shot..
			this->tankNum = tankNum;
			break;
	}

}

void EnemyTank::regeneration()
{
	while (isCollide( (pos = generatePosition(500)), radius, type, tankNum));
	pos.y = 0; // TODO should 
}

//void EnemyTank::move(WORLD_COOR coor);
//
void EnemyTank::processAction()
{
	if (hit != 0) 
		iamhit();
	tank_whatnext(this, tankNum);
}

void EnemyTank::iamhit()
{
	switch(hit) {
	case _BULLET:
		health-=9;
		break;
	case _SMART_BOMB:
		health-=1000;
		break;
	case _WALKING_BOMB:
		health-=0;
		break;
	case _BOMB:
		health-=15;
		break;
	}
	hit = 0;
	cout << health << endl;
}


//
//void EnemyTank::fireAt(WORLD_COOR coor);
//
void EnemyTank::fire()
{
	for (int i = BOMB_BASE; i <= BOMB_CAP; i++) {
		if (particles[i] == NULL) {
			particles[i] = new Particle(gun_facing_abs, pos, _BOMB, 20);
			break;
		}
	}
}

void EnemyTank::drawTank()
{


	glPushMatrix();
		glTranslatef(pos.x, pos.y, pos.z);
	//if (hit!=0) {
	//		glColor3f(1,0,0); hit = 0;}
	//	else
	//		glColor3f(0,1,1);

	float pitch;
	terrain->VehicleCollision(pos.x, pos.z-1.0, pos.x, pos.z+1.0, pos.x-1.0, pos.z, pos.x+1.0, pos.z, pitch, rolling);
	rolling *= R2D;
	facing.ver_angle = pitch*R2D;

	glRotatef(facing.ver_angle, 1,0,0);
	glRotatef(rolling, 0,0,1);
	glRotatef(facing.hor_angle, 0,1,0);

		switch(type) {
		case _JEEP:
			MD_EJ();
			break;
		case _MOMMATH:
			MD_EMM(0,0);
			break;
		case _M1:
			MD_EM1(0,0);
			break;
		}

		//glColor3f(1,1,1);
	//drawM1(tankNum);

	glPopMatrix();
}

// look, here i didnt update the pitch angle,, so this must be drawn after real tank is draw
void EnemyTank::drawBoundingBox()
{
	glPushMatrix();
	glPushName(tankNum+BLOCK_NUM);
	glTranslatef(pos.x, pos.y, pos.z);
		glRotatef(facing.ver_angle, 1,0,0);
	glRotatef(rolling, 0,0,1);
	glRotatef(facing.hor_angle, 0,1,0);
		glutSolidCube(4);
	//drawM1(tankNum);
	glPopName();
	glPopMatrix();
}

