// [ enemytank.h :::::::::::::::::::::::: ] //

/* memo	:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
	enemy tanks
	:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
*/

#ifndef _ENEMYTANK_H
#define _ENEMYTANK_H

#include "HT_Global.h"
#include "C_Brain.h"

class EnemyTank
{
public:
	// :::::::::::::::::::::::::::::::::::::::::: [ variables ]
	// :: curr state :: these should only be changed by brain()
	WORLD_COOR pos;
	FACING facing; float rolling;
	FACING gun_facing_flat, gun_facing_abs, gun_facing_rel;
	float gun_pitch;
	int health;

	float radius; // for hit detection
	float turning_speed;
	float speed, gun_turning_speed;
	int type, tankNum;

    // :: desired state :: indicators, changed by brain
	WORLD_COOR newpos;
	FACING newfacing;
	FACING intended_facing;

	// :: state indicator
	int hit;

	// :: frame counters
	int fire_holdup;

	
	float bomb_radius;
    // :::::::::::::::::::::::::::::::::::::::::: [ functions ]
	EnemyTank(int type, int tankNum);
	void regeneration();

    void move(WORLD_COOR coor);
	void processAction();
	void iamhit();

	void fireAt();
	void fire();

	void drawTank();
	void drawBoundingBox();
};


// ------------------------------------------------------------------------------------------------
#endif /* blocks.h */