
#include "C_Particle2.h"

Particledust::Particledust(WORLD_COOR pos, int type)
{
	this->pos = pos;
	this->type = type;
	
	if (type == _DUST_M) {
	// generate facing
	facing.ver_angle = rand()%90+270;
	facing.hor_angle = rand()%360;
	// generate speed
	speed = rand()%10+3;
	}
	health = 40;
}

void Particledust::processAction() {
	if (type == _DUST_S1 || type == _DUST_S2)
		animate();
	else if (type == _DUST_M)
		move();

	health-= btfactor/100;
}

void Particledust::move() {
		WORLD_COOR delta = world_coor_mult(speed/FPS_CAP*btfactor/100.0,
											normalize(Angle2Vec(facing.hor_angle, facing.ver_angle)));
		delta = world_coor_add(pos.x,pos.y,pos.z, delta.x,delta.y,delta.z);
		delta.y -= g/FPS_CAP*btfactor/100.0;
		
		facing = Vec2Angle(delta.x, delta.y, delta.z);
		pos =  delta;
}
void Particledust::animate() 
{    
}
void Particledust::drawParticle() {
	WORLD_COOR w = world_coor_add(camera.pos.x,camera.pos.y,camera.pos.z, -pos.x,-pos.y,-pos.z);
	FACING f = Vec2Angle(w.x, w.y, w.z);

			glPushMatrix();
		glTranslatef(pos.x, pos.y, pos.z);
		glRotatef(f.hor_angle, 0,1,0);
		glRotatef(f.ver_angle, 1,0,0);
		glDisable(GL_LIGHTING);
		glColor4f(1,1,1,1);

	switch(type)
	{
	case _DUST_M:

		//dust.SetActive();
		//glBegin(GL_TRIANGLE_STRIP);
		//	glTexCoord2f(0.0f, 1.0f); glVertex3f(-DUST_SIZE, DUST_SIZE, 0);
		//	glTexCoord2f(0.0f, 0.0f); glVertex3f(-DUST_SIZE, -DUST_SIZE, 0);
		//	glTexCoord2f(1.0f, 1.0f); glVertex3f(DUST_SIZE, DUST_SIZE, 0);
		//	glTexCoord2f(1.0f, 0.0f); glVertex3f(DUST_SIZE, -DUST_SIZE, 0);
		//glEnd();
		glutSolidCube(0.3);
		
		break;
	case _DUST_S2:
	case _DUST_S3:
	case _DUST_S1:

		glBlendFunc(GL_DST_COLOR,GL_ZERO);
		glEnable(GL_BLEND);									

		if(health<5) B8m.SetActive();
		else if(health<10) B7m.SetActive();
		else if(health<15) B6m.SetActive();
		else if(health<20) B5m.SetActive();
		else if(health<25) B4m.SetActive();
		else if(health<30) B3m.SetActive();
		else if(health<35) B2m.SetActive();
		else if(health<40) B1m.SetActive();
		drawTexturedQuad(-10,-10,10,10);
		glBlendFunc(GL_ONE,GL_ONE);
	if(type == _DUST_S2) glColor3f(0,1,0);
	if(type == _DUST_S3) glColor3f(1,0.6,0);
		if(health<5) B8.SetActive();
		else if(health<10) B7.SetActive();
		else if(health<15) B6.SetActive();
		else if(health<20) B5.SetActive();
		else if(health<25) B4.SetActive();
		else if(health<30) B3.SetActive();
		else if(health<35) B2.SetActive();
		else if(health<40) B1.SetActive();

		drawTexturedQuad_f(-10,-10,10,10);
		glDisable(GL_BLEND);
		glEnable(GL_LIGHTING);

		glColor3f(1,1,1);
		break;
	}
	glPopMatrix();



}

