// [ global.cpp :::::::::::::::::::::: ] //

/* memo :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
	global contains GAME CONSTANCE, GLOBAL GAME VARIABLES, GLOBAL PRIMITIVE FUNCTIONS
	& some helper functions
	:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
*/

// ------------------------------------------------------------------------------------------------
#include "HT_Global.h"

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//																				 gloabl variables

// :::::::::::::::::::::::::::::::::::::::::::::; [ GAME STATE VARIABLEs ]

// ---------------------------------------------- :: game objects ::
MetalSlug* player;
Particle* particles[BULLET_NUM+SMART_BOMB_NUM+WALKING_BOMB_NUM+BOMB];
Particledust* pdusts[PDUST_NUM];

// Picking
Blocks* blocks[BLOCK_NUM];
Blocks* deco[50];
EnemyTank* tanks[ENEMY_NUM];

//MissilePicker picker;
CTerrainMap *terrain;

// :: camera
CAMERA camera;
// :: time ::
float currTime;

// ---------------------------------------------- :: game status control ::
// :: game status control
int n_GameMode = 0;
// :: screen resolution
int n_ScreenX, n_ScreenY;
// :: bullet time factor ,, it's divided by 100
float btfactor = 100.0;
// :: on screen text
bool writeMsg = false;
int n_FIRE = 0;
bool b_LeftDown = false;
WORLD_COOR missile_target;
// :: fun stuff
int n_Hurt = 0 ;
int n_DeathCNT = 0;
int n_BF = 0;
int n_BH = 0;
int n_TimeMode = 0;


// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
//																				helper functions
void uniformAngle(float* angle)
{
	if (*angle >= 360) *angle -= 360;
	if (*angle < 0) *angle += 360;
}

void uniformFacing(FACING* f)
{
	if (f->ver_angle > 90 && f->ver_angle < 270) {
		f->hor_angle += 180;
		if (f->hor_angle >= 360) f->hor_angle -=360;

		f->ver_angle = 540 - f->ver_angle;
		if (f->ver_angle >=360) f->ver_angle -= 360;
	}
}

FACING Vec2Angle(float a, float b, float c)
// calculate FACING from a vec
{
	FACING temp; float t;
	if (c<0)
		t = PI + atan(a/c);
	else if (a >=0)
		t = atan(a/c);
	else if (a<0)
		t = 2*PI + atan(a/c);
	temp.hor_angle = t*180/PI;

	if (c<0) {
		t = PI + atan(b/sqrt(a*a+c*c));
		temp.hor_angle -=180;
		if (temp.hor_angle < 0) temp.hor_angle+=360;
	}
	else if (b <= 0)
		t = atan(-b/sqrt(a*a+c*c));
	else if (b > 0)
		t = 2*PI - atan(b/sqrt(a*a+c*c));
    temp.ver_angle = t*180/PI;

	uniformFacing(&temp);

	return temp;
}

WORLD_COOR Angle2Vec(float hor, float ver)
// calculate vector from angle
{
	WORLD_COOR temp;
	temp.z = cos(hor*PI/180);
	temp.x = sin(hor*PI/180);

	if (ver > 90 && ver < 270) {
		temp.y = tan(ver*PI/180);
		temp.z = -temp.z;
		temp.x = -temp.x;
	}
	else 
		temp.y = -tan(ver*PI/180);

	return temp;
}

WORLD_COOR world_coor_add(float a, float b, float c, float x, float y, float z)
// add 2 WORLD_COOR to return a WORLD_COOR
{
	WORLD_COOR temp;
	temp.x = a + x;
	temp.y = b + y;
	temp.z = c + z;
	return temp;
}

WORLD_COOR world_coor_mult(float a, WORLD_COOR v)
// multiply a vector (WORLD_COOR) by a scaler
{
	v.x *= a; v.y *= a; v.z *= a;
	return v;
}

WORLD_COOR normalize(WORLD_COOR v) 
{
	float d = sqrt(v.x*v.x + v.y*v.y + v.z*v.z);
	if (d == 0.0) {
		return v;
	}
	v.x /= d; v.y /= d; v.z /= d;
	return v;
}

float veclength(WORLD_COOR v)
{
	float d = sqrt(v.x*v.x + v.y*v.y + v.z*v.z);
	return d;
}

// :: now vector rotation ::
WORLD_COOR roll(float angle, WORLD_COOR coor)
{
	WORLD_COOR result; float r= angle*D2R;
	float s = sin(r), c = cos(r);
	result.x = coor.x*c - coor.y*s;
	result.y = coor.x*s + coor.y*c; // done roll
	
	result.z = coor.z;
	return result;
}

WORLD_COOR pitch(float angle, WORLD_COOR coor)
{
	WORLD_COOR result; float a = angle*D2R;
	float s = sin(a), c = cos(a);
	result.y = coor.y*c - coor.z*s;
	result.z = coor.y*s + coor.z*c; // done roll
	
	result.x = coor.x;
	return result;
}

WORLD_COOR yaw(float angle, WORLD_COOR coor)
{
	WORLD_COOR result; float a = angle*D2R;
	float s = sin(a), c = cos(a);
	result.x = coor.x*c + coor.z*s;
	result.z = -coor.x*s + coor.z*c; // done roll
	
	result.y = coor.y;
	return result;
}

FACING abs2rel(float r, float p, float y, FACING f)
{
	WORLD_COOR result = yaw(y, roll(r, pitch(p, Angle2Vec(f.hor_angle, f.ver_angle))));
	FACING temp = Vec2Angle(result.x, result.y, result.z);
	uniformFacing(&temp);
	return temp;
}
FACING rel2abs(float r, float p, float y, FACING f)
{
	WORLD_COOR result = pitch(p, roll(r, yaw(y, Angle2Vec(f.hor_angle, f.ver_angle))));
	FACING temp = Vec2Angle(result.x, result.y, result.z);
	uniformFacing(&temp);
	return temp;
}

WORLD_COOR generatePosition(int terrainSize)
{
	WORLD_COOR temp;
	int num;
	
	srand(glutGet(GLUT_ELAPSED_TIME));
	while ( (num=rand()%terrainSize) < player->pos.x + 128 && num > player->pos.x - 128 );
	temp.x =  num - terrainSize/2;
	while ( (num=rand()%terrainSize) < player->pos.z + 128 && num > player->pos.z - 128 );
	temp.z =  num - terrainSize/2;	
	temp.y = 0;
	return temp;
}

void emitParticle(WORLD_COOR pos, int type, int num)
{
	for (int i=0; i < PDUST_NUM; i++)
	{
		if (pdusts[i] == NULL)
		{
			pdusts[i] = new Particledust(pos, type);
			num--;
		}
		if (num == 0) break;
	}
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
//																			 primitive functions 

// :::::::::::::::::::::::::::::::::::::::::::::: [ INITIALIZE GAME ]
void initGame()
// bulk function
{
	
	terrain = new CTerrainMap(1, 8888);
	initGameobjects();
	loadHUDTextures();
	loadPTextures();
	loadNumTextures();
	setCamera();
	// set mouse to center
	glutWarpPointer(RES_X/2, RES_Y/2);

	// load all models
	MD_Init();


	// initial all the display lists
	//initM1DL();
	//initPart();
}
void initGameobjects()
{
	// :: initial MetalSlug ::
	player = new MetalSlug;

	// :: initiate blocks ::
	for (int i=0; i<BLOCK_NUM; i++) {
		// TODO

		int x = rand()%300;

		int z = rand()%300;
		blocks[i] = new Blocks(x,0,z, 20,20,20, i,40);
	}
	for (int i=0; i<50; i++) 
	{
		// TODO
		int ax = rand()%600;
		int z = rand()%600;
		int x = (int)ax/128 *128;
		//int z = (int)az/128 *128;
		if(i < 14) deco[i] = new Blocks(x,0,z, 0,0,0, i,47);
		if(i < 30) deco[i] = new Blocks(x,0,z, 0,0,0, i,43);
		if(i < 50) deco[i] = new Blocks(x,0,z, 0,0,0, i,45);
		//if(i < 10) deco[i] = new Blocks(x,0,z, 0,0,0, i,46);
		//if(i < 16) deco[i] = new Blocks(x,0,z, 0,0,0, i,44);
		if(i < 18) deco[i] = new Blocks(x,0,z, 0,0,0, i,44);
		else deco[i] = new Blocks(x,0,z, 0,0,0, i,41);

	}

	// :: initiate enemy tanks
	for (int i=0; i<ENEMY_NUM; i++) {
		// todo
		// generate position, facing, 
		if (i< 5) { 
			tanks[i] = new EnemyTank(_M1, i); }
		else if (i<8) {
			tanks[i] = new EnemyTank(_MOMMATH, i); }
		else {
			tanks[i] = new EnemyTank(_JEEP, i); }

	}
	// here regenerate tank at some position
	for (int i=0; i<ENEMY_NUM; i++) {
		// todo
		// generate position, facing, 
		tanks[i]->regeneration();
	}
    
	// :: initial particles ::
	for (int i=0; i<BULLET_NUM+SMART_BOMB_NUM+WALKING_BOMB_NUM+BOMB; i++)
		// just initiate them all as null
	{ 
		particles[i] = NULL;
	}
	for (int i=0; i<PDUST_NUM; i++)
	// just initiate them all as null
	{ 
		pdusts[i] = NULL;
	}

//	picker.Initialize();
}

// :::::::::::::::::::::::::::::::::::::::::::::: [ PROCESS GAME ]
void processGame()
{	

	for (int i=0; i<PDUST_NUM; i++) {
		if (pdusts[i] != NULL) {
			if (pdusts[i]->health < 0) {
				// TODO,, here particle do explosive effect
				pdusts[i] = NULL;
			}
			else
				pdusts[i]->processAction();
		}
	}
	for (int i=0; i<BULLET_NUM+SMART_BOMB_NUM+WALKING_BOMB_NUM+BOMB; i++) {
		if (particles[i] != NULL) {
			if (particles[i]->health < 0) {
				// TODO,, here particle do explosive effect
				if (particles[i]->type == _SMART_BOMB || particles[i]->type == _BOMB)
					for (int ii=0; ii<PDUST_NUM; ii++)
					{
						if (pdusts[ii] == NULL) {
							if (particles[i]->type == _BOMB && particles[i]->health != -10000) 
							pdusts[ii] = new Particledust(particles[i]->pos, _DUST_S3);
							else if (particles[i]->type == _SMART_BOMB) pdusts[ii] = new Particledust(particles[i]->pos, _DUST_S2);
							break;
						}
					}
					particles[i] = NULL;
			}
			else particles[i]->processAction();

		}
	}
	for (int i=0; i<ENEMY_NUM; i++) {
		if (tanks[i] != NULL)
			tanks[i]->processAction();
	}
	player->processAction();
	setCamera();
}


// :::::::::::::::::::::::::::::::::::::::::::::: [ CAMERA SETUP ]
void setCamera()
// camera should be set every time player changes position or its gun_facing
{
	float ver_angle = player->gun_facing_abs.ver_angle+210;
	if (ver_angle > 360) ver_angle-=360;
	WORLD_COOR temp = Angle2Vec(player->gun_facing_abs.hor_angle, ver_angle); // camera is at 60 degree back

	temp = world_coor_mult(CAM_TANK_DISTANCE, normalize(temp));
	temp = world_coor_add(player->pos.x,player->pos.y,player->pos.z,temp.x,temp.y,temp.z ); 
	if (temp.y < 0) temp.y = 0;
	camera.pos = temp;
	float tempY = terrain->CollisionPoint(camera.pos.x, camera.pos.z); tempY+=2;
	if (tempY > camera.pos.y)
		camera.pos.y = tempY;

	temp = Angle2Vec(player->gun_facing_abs.hor_angle, player->gun_facing_abs.ver_angle);	// the vector that gun points at
	temp = world_coor_mult(AIMING_DISTANCE, normalize(temp));
	temp = world_coor_add(player->pos.x,player->pos.y,player->pos.z, temp.x,temp.y,temp.z);

	camera.lookAt = temp;
}

// :::::::::::::::::::::::::::::::::::::::::::::: [ TIME BASED CONTROL ]
int frame = 0, FPS = 0; float FPS_timebase = 0;

void getFPS()
{
	frame++;
	if (Wait(1000, FPS_timebase)) {
		FPS = frame;
		frame = 0;
		Sync(&FPS_timebase);
	}
}

bool Wait(float duration,float counter)
{
	return( currTime - counter ) > ( duration );	
}

void Sync(float * counter )
{
	*counter = glutGet(GLUT_ELAPSED_TIME);
}

void Syncro(double * counter )
{
	*counter = glutGet(GLUT_ELAPSED_TIME);
}

bool StopWhenClose(float *motion_angle, double target_angle)
{
	if(abs(target_angle-*motion_angle) < 0.005)
	{
		*motion_angle = target_angle;
		return true;
	}
	else return false;
}
bool StopWhenClose(double *motion_angle, double target_angle)
{
	if(abs(target_angle-*motion_angle) < 0.005)
	{
		*motion_angle = target_angle;
		return true;
	}
	else return false;
}
bool StopWhenClose(double *motion_angle, double target_angle, int range)
{
	if(abs(target_angle-*motion_angle) < range)
	{
		*motion_angle = target_angle;
		return true;
	}
	else return false;
}


// :::::::::::::::::::::::::::::::::::::::::::::: [ IN GAME SCREEN TEXT ]
char message[1024];
void writeText(int x, int y)
// write text to screen (e.g. help menu, status display)
{
	int Viewport[4];
	glGetIntegerv(GL_VIEWPORT, Viewport);


	glDisable(GL_LIGHTING);
	glColor3f(0, 1, 0);						// Heads up green
	glMatrixMode(GL_PROJECTION);			// switch to projection mode
	glPushMatrix();							// save previous matrix (perspective)
		glLoadIdentity();					// reset matrix
		gluOrtho2D(0, Viewport[2], 0, Viewport[3]);	// set a 2D orthographic projection
		glScalef(1, -1, 1);					// invert the y axis, down is positive
		glTranslatef(0, 13-Viewport[3], 0);		// move origin from bottom to top
		glMatrixMode(GL_MODELVIEW);
		glPushMatrix();
			glLoadIdentity();
			char *c;
			glRasterPos2f(x, y);
			int rasterY = y;
			for (c=message; *c != '\0'; c++)					// write each char
			{
				if ( *c == '\n' )									// if line break
				{
					rasterY += 13;									// height of text
					glRasterPos2f(0, rasterY);						// next line
				}
				else glutBitmapCharacter(GLUT_BITMAP_8_BY_13, *c);	// write text
			}
		glPopMatrix();
		glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	glMatrixMode(GL_MODELVIEW);
	glEnable(GL_LIGHTING);
}
void updateText(void)
// this function displays most variable information; the code is self explanatory
{
	int chars = sprintf( message, "      ----- STATUS -----\n\n");
//	if ( particles[SB_BASE] != NULL) {
//		chars += sprintf( message+chars, "missile : %f\n", particles[SB_BASE]->pos.x);
//		chars += sprintf( message+chars, "missile  : %f\n", particles[SB_BASE]->pos.y);
//	chars += sprintf( message+chars, "missile : %f\n", particles[SB_BASE]->pos.z);
//
//	chars += sprintf( message+chars, "\nmissile : %f\n", particles[SB_BASE]->facing.hor_angle);
//	chars += sprintf( message+chars, "missile  : %f\n", particles[SB_BASE]->facing.ver_angle);
//	chars += sprintf( message+chars, "missile : %f\n", particles[SB_BASE]->pos.z);
//	}
	//
	//for (int i=0; i<PDUST_NUM; i++) {
	//	if ( pdusts[i] != NULL) {

	//		chars += sprintf( message+chars, "missile : %f\n", pdusts[i]->pos.x);
	//		chars += sprintf( message+chars, "missile  : %f\n", pdusts[i]->pos.y);
	//		chars += sprintf( message+chars, "missile : %f\n\n", pdusts[i]->pos.z);
	//	}
	//}
chars += sprintf( message+chars, "hurt : %d\n", n_Hurt);
	chars += sprintf( message+chars, "fired : %d\n", n_BF);
	chars += sprintf( message+chars, "hit : %d\n", n_BH);
	chars += sprintf( message+chars, "killed : %d\n", n_DeathCNT);
//
//
//	chars += sprintf( message+chars, "tank facing hor  : %d\n", tanks[0]->health);
//	chars += sprintf( message+chars, "tank facing ver  : %d\n", tanks[0]->health);
//	chars += sprintf( message+chars, "tank facing hor  : %d\n", tanks[1]->health);
//	chars += sprintf( message+chars, "tank facing ver  : %d\n", tanks[1]->health);
//	chars += sprintf( message+chars, "tank facing hor  : %d\n", tanks[2]->health);
//	chars += sprintf( message+chars, "tank facing ver  : %d\n", tanks[2]->health);
//	chars += sprintf( message+chars, "tank facing hor  : %d\n", tanks[3]->health);
//	chars += sprintf( message+chars, "tank facing ver  : %d\n", tanks[3]->health);

	//chars += sprintf( message+chars, "gun facing hor  : %f\n", tanks[0]->gun_pitch);
	//chars += sprintf( message+chars, "gun facing abs ver  : %f\n", tanks[0]->gun_facing_abs.ver_angle);
	//chars += sprintf( message+chars, "gun facing abs hor  : %f\n", tanks[0]->gun_facing_abs.hor_angle);

	//chars += sprintf( message+chars, "gun facing flat ver  : %f\n", tanks[0]->gun_facing_flat.ver_angle);

	//chars += sprintf( message+chars, "gun facing rel ver  : %f\n", tanks[0]->gun_facing_rel.ver_angle);
	//chars += sprintf( message+chars, "gun facing rel hor  : %f\n", tanks[0]->gun_facing_rel.hor_angle);




	//chars += sprintf( message+chars, "cam at  : %f\n", camera.pos.x);
	//chars += sprintf( message+chars, "cam at  : %f\n", camera.pos.y);
	//chars += sprintf( message+chars, "cam at  : %f\n", camera.pos.z);

	//chars += sprintf( message+chars, "cam facing at  : %f\n", camera.lookAt.x);
	//chars += sprintf( message+chars, "cam facing at  : %f\n", camera.lookAt.y);
	//chars += sprintf( message+chars, "cam facing at  : %f\n", camera.lookAt.z);

	//chars += sprintf( message+chars, "tank intened facing  : %f\n", tanks[0]->intended_facing.hor_angle);
	//chars += sprintf( message+chars, "tank intened facing  : %f\n", tanks[0]->intended_facing.ver_angle);

	//chars += sprintf( message+chars, "tank facing  : %f\n", tanks[0]->facing.hor_angle);
	//chars += sprintf( message+chars, "tank facing  : %f\n", tanks[0]->facing.ver_angle);

	//chars += sprintf( message+chars, "tank pos  : %f\n", tanks[0]->pos.x);
	//chars += sprintf( message+chars, "tank pos  : %f\n", tanks[0]->pos.y);
	//chars += sprintf( message+chars, "tank pos  : %f\n", tanks[0]->pos.z);

	//chars += sprintf( message+chars, "gun facing  : %f\n", tanks[0]->gun_facing_abs.hor_angle);
	//chars += sprintf( message+chars, "gun facing  : %f\n", tanks[0]->gun_facing_abs.ver_angle);	


	//chars += sprintf( message+chars, "player gun  : %f\n", player->gun_facing.hor_angle);
	//chars += sprintf( message+chars, "player gun  : %f\n", player->gun_facing.ver_angle);


	//chars += sprintf( message+chars, "left gun angle  : %f\n", player->gun_facing_rel.hor_angle );
	//chars += sprintf( message+chars, "left gun angle  : %f\n", player->gun_facing_rel.hor_angle );


	//for (int i=0; i<3; i++) {
	//if (particles[i] != NULL) {
	//chars += sprintf( message+chars, "bullet facing at  : %f\n", particles[i]->target.x);
	//chars += sprintf( message+chars, "bullet facing at  : %f\n", particles[i]->target.y);
	//chars += sprintf( message+chars, "bullet facing at  : %f\n", particles[i]->target.z);
	//chars += sprintf( message+chars, "bullet facing at  : %f\n", particles[i]->facing.hor_angle);
	//chars += sprintf( message+chars, "bullet facing at  : %f\n", particles[i]->facing.ver_angle);
	//chars += sprintf( message+chars, "\n");
	
	//}}
	
	chars += sprintf( message+chars, "FPS  : %d\n", FPS);
}
// ------------------------------------------------------------------------------------------------
// end of file "global.cpp"