
// [ HT_Global.h :::::::::::::::::::::::: ] //


/* memo :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
	global contains GAME CONSTANCE, GLOBAL GAME VARIABLES, GLOBAL PRIMITIVE FUNCTIONS
	& some helper functions
	:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
*/

#ifndef _HT_GLOBAL_H
#define _HT_GLOBAL_H
// ------------------------------------------------------------------------------------------------

#include <stdlib.h>
#include <stdio.h>
#include <GL/glut.h>
#include <math.h>
#include <iostream>
using namespace std;

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
//																		self defined structures
// :: structures used for simple coding style
typedef struct FACEING {
	float hor_angle, ver_angle;
} FACING;

typedef struct WORLD_COOR {
	float x, y, z;
} WORLD_COOR;

typedef struct CAMERA {
	WORLD_COOR pos;
	WORLD_COOR lookAt;
} CAMERA;
// :: pseudo define classes
// TODO
class MetalSlug;
class Blocks;
class EnemyTank;
class Particle;
class Particledust;

// :: real includes for above classes
// TODO
#include "C_MetalSlug.h"
#include "C_Blocks.h"
#include "C_EneTanks.h"
#include "C_Particle1.h"
#include "C_Particle2.h"
#include "TerrainMap.h"
#include "modelDrawing.h"
#include "textureDrawing.h"
#include "obj_MenuBack.h"

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//																					gloabl const

// :::::::::::::::::::::::::::::::::::::::::::::: [ GAME SETTINGS ]

// game defaul resolution is RES_X, RES_Y
const int RES_X=800, RES_Y=600;		

// video settings
const int FPS_CAP = 60;

// game settings
// =============
// :: setup game objects containers
const int BLOCK_NUM = 10;
const int ENEMY_NUM = 10;
const int PDUST_NUM = 100;
//		particles all collected here,, since i want to process them indifferently..
//		payed off is we have to be careful to set up the numbers here
const int BULLET_NUM = 30, BULLET_BASE = 0, BULLET_CAP = 29;
const int SMART_BOMB_NUM = 3, SB_BASE = 30, SB_CAP = 32;
const int WALKING_BOMB_NUM = 7, WB_BASE = 33, WB_CAP = 39;
const int BOMB = 25, BOMB_BASE = 40, BOMB_CAP = 64;
//		world size
const int WORLD_SIZE = 1000;
//		define the speed of game progress,, PER SECOND !! not per frame
//		:: player tank
//		:: enemy tank should be a factor times this speed // look into brain for speed detail
const float METALSLUG_SPEED = 30;
const float METALSLUG_TURNING_SPEED = 180;
const float METALSLUG_RADIUS = 1;
//		:: other tanks
const float TANK_SPEED = 20;
const float TANK_TURNING_SPEED = 100;
const float TANK_GUN_TURNING_SPEED = 150;
const int TANK_FIRE_HOLDUP_COUNTER = 1;
//		:: particle speed
//		:: as well,, this is the max speed, // look into brain for speed detail
const int BULLET_SPEED = 90;
const float WB_SPEED = 60;
const int BOMB_SPEED = 120;
const int BOMB_A_SPEED = 45;
const float SB_TURNING_SPEED = 180; // this is angle
extern int n_FIRE;
extern bool b_LeftDown;
// camera
const int AIMING_DISTANCE = 128;
const int CAM_TANK_DISTANCE = 2;
// camera sensitivity is not set here,, look into mouse function

// other constants used
const float PI = 3.1415926;
#define R2D 57.2957795
#define D2R 0.01745329252
const float g = 2;
const int CHARSIZE = 30;

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//																					gloabl variable

// :::::::::::::::::::::::::::::::::::::::::::::; [ GAME OBJECTS AND STATE VARIABLEs ]

// ---------------------------------------------- :: game objects ::
#define _BULLET 1
#define _SMART_BOMB 2
#define _WALKING_BOMB 3
#define _BOMB 4
#define _PLAYER 5

#define _MOMMATH	11
#define _M1			12
#define _JEEP		13

#define _DUST_S1		20
#define _DUST_S2		21
#define _DUST_S3		22
#define _DUST_M			23

#define DUST_SIZE	0.3


extern MetalSlug* player;
extern Blocks* blocks[BLOCK_NUM];
extern Blocks* deco[50];
extern EnemyTank* tanks[ENEMY_NUM];
extern Particle* particles[BULLET_NUM+SMART_BOMB_NUM+WALKING_BOMB_NUM+BOMB];
extern Particledust* pdusts[PDUST_NUM];
extern CTerrainMap *terrain;

// :: camera ::
extern CAMERA camera;
// :: time :: this is a global time,, everything behave according to this time
extern float currTime;


// ---------------------------------------------- :: game status control ::
// :: game status control ::
extern int n_GameMode;
// :: screen resolution
extern int n_ScreenX, n_ScreenY;
// :: bullet time factor
extern float btfactor; // <-- update btfactor in idle to achieve bullet time.. && bt time = 0 to freeze time -- pause game
// :: on screen display text
extern bool writeMsg;

// :: particle replacement findme

// Missile target coordinates
//extern MissilePicker picker;
extern WORLD_COOR missile_target;
// :: fun factor

extern int n_Hurt;
extern int n_DeathCNT;
extern int n_BF;
extern int n_BH;
extern int FPS;
extern int n_TimeMode;
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
//																				helper functions
void uniformAngle(float* angle);
void uniformFacing(FACING* f);
FACING Vec2Angle(float a, float b, float c);
WORLD_COOR Angle2Vec(float hor, float ver);
WORLD_COOR add(WORLD_COOR coor1,WORLD_COOR coor2);
WORLD_COOR world_coor_add(float a, float b, float c, float x, float y, float z);
WORLD_COOR world_coor_mult(float a, WORLD_COOR v);

WORLD_COOR normalize(WORLD_COOR v);
float veclength(WORLD_COOR v);

WORLD_COOR roll(float angle, WORLD_COOR coor);
WORLD_COOR pitch(float angle, WORLD_COOR coor);
WORLD_COOR yaw(float angle, WORLD_COOR coor);
FACING abs2rel(float roll, float pitch, float yaw, FACING f);
FACING rel2abs(float r, float p, float y, FACING f);

void writeText(int x, int y);
void updateText();

WORLD_COOR generatePosition(int terrainSize);
void emitParticle(WORLD_COOR pos, int type, int num);

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
//																				primitive functions 
// :: functions dump
// :: code that does primitive jobs such as initialize game, draw background, do menu and so on
// :: which does not need a class

// :::::::::::::::::::::::::::::::::::::::::::::: [ INITIALIZE GAME ]
void initGame();
void initDLs();
void initGameobjects();
void setCamera();	// take player position to set up camera position,, need player setup first

// :::::::::::::::::::::::::::::::::::::::::::::: [ PROCESS GAME ]
void processGame(); // idle only need to call this

// :::::::::::::::::::::::::::::::::::::::::::::: [ TIME BASED CONTROL ]
void Awake(int value);
bool Wait(float duration,float counter);
void Sync(float * counter );
void getFPS();

// :::::::::::::::::::::::::::::::::::::::::::::: [ IN GAME SCREEN TEXT ]
void writeText();
bool StopWhenClose(double *motion_angle, double target_angle);
void Syncro(double * counter );
bool StopWhenClose(double *motion_angle, double target_angle, int range);
// :::::::::::::::::::::::::::::::::::::::::::::: [ MORE ... ]
#include "drawingFuncDump.h"
#include "textureDrawing.h"
#include "C_Brain.h"

// ------------------------------------------------------------------------------------------------
#endif /* global.h */
