// Picking for Missles
// Implementation heavily influenced by Lighthouse 3D (www.lighthouse3d.com)

#pragma once
#include "HT_Global.h"
#include <GL/glut.h>

#define BUFFERSIZE 1024

class MissilePicker
{
public:
	// This must be run before using the other two functions
	void Initialize(void);
	
	// render for picking
	void Render(const int cursorX, const int cursorY);

	// returns true if an object was picked
	bool GetPickedObject(float &objectX, float &objectY, float &objectZ);

private:
	void StartPicking(const int &cursorX, const int &cursorY);
	void StopPicking(void);
	GLuint ProcessHits(void);
	
	GLuint	m_Buffer[BUFFERSIZE];
	GLint	m_Hits;
	
	GLuint m_ObjectDL;
};